﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _02_Page_ClientCallBack : 
    System.Web.UI.Page, System.Web.UI.ICallbackEventHandler
{
    // コールバック処理の結果格納用変数
    private String result;

    // 呼び出されるコールバックメソッド
    public void RaiseCallbackEvent(String arg) {
        RandomCalc(); //乱数を生成
    }
    // コールバック処理の応答用メソッド
    public String GetCallbackResult() {
        return this.result;
    }
    //乱数生成
    private void RandomCalc() {
        Random rnd = new Random();
        if (Page.IsCallback) { //コールバックか
            this.result = "コールバック処理：" + rnd.Next().ToString();
        } else {
            Label1.Text = rnd.Next().ToString(); //初期表示で呼び出し
        }
    }
    //初期設定
    protected void Page_Load(Object sender, EventArgs e) {
        // クライアント関数への参照を取得
        String cbRef = Page.ClientScript.GetCallbackEventReference(
            this, //コールバック用コントロール(Page)
            null, //サーバに送信する関数
            "myCallBackScript", //成功時のクライアントスクリプト
            "null"); //コールバック開始前のクライアントスクリプト
        //ボタンにコールバック関数を登録
        Button1.OnClientClick = cbRef + ";return false;";
        //数字を初期表示
        RandomCalc();
    }
}

