﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Threading;

public partial class _02_Page_PageAsync : System.Web.UI.Page
{
    private AsyncTaskDelegate _delegate;
    protected delegate void AsyncTaskDelegate();

    protected void Page_Load(object sender, EventArgs e)
    {
        // 非同期実行の準備
        if (Page.IsAsync == true) {
            Page.AsyncTimeout = new TimeSpan(0,0,5);  //5秒でタイムアウト
            PageAsyncTask task = new PageAsyncTask(BeginEvent, EndEvent, TimeoutData, null, true);
            Page.RegisterAsyncTask(task);
        }
    }
    //非同期処理の開始イベント
    IAsyncResult BeginEvent(object sender, EventArgs e, AsyncCallback callback, object state) {
        //非同期のメソッドを登録
        _delegate = new AsyncTaskDelegate(SlowCalcMethod);
        return _delegate.BeginInvoke(callback, state);
    }
    //時間のかかるメソッド
    public void SlowCalcMethod() {
        Thread.Sleep(TimeSpan.FromSeconds(3.0)); //3秒
        Label1.Text = "正常終了";
    }
    //非同期処理の終了イベント
    void EndEvent(IAsyncResult ar) {
        //終処理
        _delegate.EndInvoke(ar);
    }
    //タイムアウト時の処理
    void TimeoutData(IAsyncResult ar) {
        Label1.Text = "タイムアウトです";
    }
}
