﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _02_Page_Request : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //ユーザーを一意に識別する一時的なCookieを設定
        if (Request.Cookies["UniqueKey"] == null) {
            Response.Cookies["UniqueKey"].Value = Guid.NewGuid().ToString();
        }
    }

    protected void LinkButton1_Click(object sender, EventArgs e) {

        Label1.Text = ""; //フォーム変数→VIEWSTATE等
        for (int i = 0; i < Request.Form.Count; i++) {
            Label1.Text += "<br />"+ Request.Form.GetKey(i); 
        }
        Label2.Text = Request.QueryString["selectId"];
        //クエリ文字列→Request.aspx?selectId=200の場合、200
        Label3.Text = Request.ServerVariables["HTTP_ACCEPT_LANGUAGE"];
        //サーバー変数(言語コード)→ja,en-us;q=0.5
        Label4.Text = Request.Cookies["UniqueKey"].Value;
        //Cookie(UniqueKey) →36桁の一意なID(3b6cf866-932a-･･･)
        Label5.Text = Request.RequestType;
        //HTTPメソッド→ POST
        Label6.Text = Request.UserAgent;
        //ブラウザのユーザーエージェント→ Mozilla/4.0 (compatible; ･･･
        Label7.Text = Request.Url.AbsoluteUri;
        //絶対URL→ http://localhost:8080/Jiten/02/Page/Request.aspx?selectId=200
        Label8.Text = Request.ApplicationPath;
        //ルートパス→ /Jiten
        Label9.Text = Request.AppRelativeCurrentExecutionFilePath;
        //相対パス→ ~/02/Page/Request.aspx
        Label10.Text = Request.CurrentExecutionFilePath;
        //仮想パス→ /Jiten/02/Page/Request.aspx
    }
}
