﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _05_DetailsView_DetailsEvents : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    //データ挿入前イベント
    protected void Dv1_ItemInserting(object sender, DetailsViewInsertEventArgs e) {
        foreach (DictionaryEntry de in e.Values){
            if (de.Value == null) { //入力パラメータをチェック
                Label1.Text = "入力データが不足してます";
                e.Cancel = true; //挿入処理をキャンセル
                return;
            }
        }
        //登録日と更新日のパラメータに現在日時をセット
        Sql1.InsertParameters["modify_date"].DefaultValue = DateTime.Now.ToString("f");
        Sql1.InsertParameters["create_date"].DefaultValue = DateTime.Now.ToString("f");
    }

    //データ挿入後イベント
    protected void Dv1_ItemInserted(object sender, DetailsViewInsertedEventArgs e) {
        Label1.Text = e.AffectedRows + "件登録されました<br />登録結果<br />";
        foreach (DictionaryEntry de in e.Values) {
            Label1.Text += de.Key + ":" + de.Value + "<br />";
        }
        e.KeepInInsertMode = true; //引き続きデータを入力
    }

    //データ更新前イベント
    protected void Dv1_ItemUpdating(object sender, DetailsViewUpdateEventArgs e) {
        foreach (DictionaryEntry de in e.NewValues) {
            if (de.Value == null) {//入力パラメータをチェック
                Label1.Text = "入力データが不足してます";
                e.Cancel = true; //更新処理をキャンセル
                return;
            }
        }//更新日のパラメータに現在日時をセット
        Sql1.UpdateParameters["modify_date"].DefaultValue = DateTime.Now.ToString("f");
    }

    //データ更新後イベント
    protected void Dv1_ItemUpdated(object sender, DetailsViewUpdatedEventArgs e) {
        Label1.Text = e.AffectedRows + "件更新されました<br />更新前データ<br />";
        foreach (DictionaryEntry de in e.OldValues) {
            Label1.Text += de.Key + ":" + de.Value + "<br />";
        }
    }

    //データ削除前イベント
    protected void Dv1_ItemDeleting(object sender, DetailsViewDeleteEventArgs e) {
        if (Dv1.DataItemCount <= 5) {
            Label1.Text = "5件以下にはできません";
            e.Cancel = true;
        }
    }

    //データ削除後イベント
    protected void Dv1_ItemDeleted(object sender, DetailsViewDeletedEventArgs e) {
        Label1.Text = e.AffectedRows + "件削除されました<br />削除データのキー<br />";
        foreach (DictionaryEntry de in e.Keys) {
            Label1.Text += de.Key + ":" + de.Value + "<br />";
        }
    }

    //データ生成時イベント
    protected void Dv1_ItemCreated(object sender, EventArgs e) {
        if (Dv1.CurrentMode == DetailsViewMode.ReadOnly) {
            //削除ボタン(6行目→1列目→左から3つめ)に確認スクリプトを追加
            LinkButton del = (LinkButton)Dv1.Rows[5].Cells[0].Controls[2];
            del.OnClientClick = "javascript:return confirm('" + 
            (string)DataBinder.Eval(Dv1.DataItem, "name") + "を削除しますか" + "')";
        }
    }

    //コマンド時のイベント
    protected void Dv1_ItemCommand(object sender, DetailsViewCommandEventArgs e) {
        if (e.CommandName == "HIDE") {
            Dv1.Fields[5].Visible = false; //編集ボタンを非表示
            Dv1.Fields[6].Visible = false; //隠すボタンを非表示
        }
    }
}
