﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _05_Repeater_RepeaterItem : System.Web.UI.Page{

    int sumPrice = 0; //全メニューの価格合計

    //各アイテムの生成時
    protected void Rpt1_ItemCreated(object sender, RepeaterItemEventArgs e) {
        if (e.Item.ItemType == ListItemType.Item || //(交互)項目であれば
           e.Item.ItemType == ListItemType.AlternatingItem) {
            int rowNum = e.Item.ItemIndex + 1; //レコードの連番をラベルに設定
            ((Label)e.Item.FindControl("lblNum")).Text += rowNum.ToString();
        }
    }
    //各アイテムのデータバインド時
    protected void Rpt1_ItemDataBound(object sender, RepeaterItemEventArgs e) {
        if (e.Item.ItemType == ListItemType.Item ||  //(交互)項目であれば
            e.Item.ItemType == ListItemType.AlternatingItem) {
            sumPrice += (int)DataBinder.Eval(e.Item.DataItem, "price"); //価格合計
        }
    }
    //レンダリング前にラベルに平均価格を設定
    protected void Rpt1_PreRender(object sender, EventArgs e) {
        //リピータの項目数がゼロ件でなければ平均価格を計算
        if (Rpt1.Items.Count != 0) { 
            int avgPrice = sumPrice / (Rpt1.Items.Count);
            lblAvg.Text = "平均価格 : " + avgPrice.ToString("c");
       }
    }
}
