﻿using System;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

using System.ComponentModel; //DataObjectMethod属性用

public class DrinkDao{
    //コンストラクタ必須(ObjectDataSourceによって呼び出される)
	public DrinkDao(){}

    //SELECTメソッド(DataObjectMethod属性はVSのウィザード用)
    [DataObjectMethod(DataObjectMethodType.Select)]
    public DataSet Select() {
        // System.Data.SqlClient名前空間;
        DataSet ds = new DataSet();
        String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
        string query = "SELECT id,name, price FROM drink";
        using (SqlConnection con = new SqlConnection(conStr)) {
            SqlDataAdapter adapter = new SqlDataAdapter(query, con);
            adapter.Fill(ds);
        }
        return ds;
    }

    //UPDATE(DataObjectMethod属性はVSのウィザード用)
    [DataObjectMethod(DataObjectMethodType.Update)]
    public int Update(int id, string name, int price) {
        int ret;
        String conStr = ConfigurationManager.
            ConnectionStrings["MyCon"].ConnectionString;
        using (SqlConnection con = new SqlConnection(conStr)) {
            SqlCommand cmd = new 
                SqlCommand("UPDATE drink SET [name] = @name, [price] = @price WHERE [id] = @id", con);
            cmd.Parameters.AddWithValue("@id", id);
            cmd.Parameters.AddWithValue("@name", name);
            cmd.Parameters.AddWithValue("@price", price);
            con.Open();
            ret = cmd.ExecuteNonQuery();
        }
        return ret;
    }

    //INSERT(DataObjectMethod属性はVSのウィザード用)
    [DataObjectMethod(DataObjectMethodType.Insert)]
    public int Insert(int id, string name, int price) {
        int ret;
        String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
        using (SqlConnection con = new SqlConnection(conStr)) {
            SqlCommand cmd = new SqlCommand("INSERT INTO [drink] ([id], [name], [price]) VALUES (@id, @name, @price)", con);
            cmd.Parameters.AddWithValue("@id", id);
            cmd.Parameters.AddWithValue("@name", name);
            cmd.Parameters.AddWithValue("@price", price);
            con.Open();
            ret = cmd.ExecuteNonQuery();
        }
        return ret;
    }

    //DELETE(DataObjectMethod属性はVSのウィザード用)
    [DataObjectMethod(DataObjectMethodType.Delete)]
    public int Delete(int id) {
        int ret;
        String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
        using (SqlConnection con = new SqlConnection(conStr)) {
            SqlCommand cmd = new SqlCommand("DELETE FROM [drink] WHERE [id] = @id", con);
            cmd.Parameters.AddWithValue("@id", id);
            con.Open();
            ret = cmd.ExecuteNonQuery();
        }
        return ret;
    }
}
