﻿using System;
using System.Data;
using System.Configuration;
using System.Collections.Generic;
using System.Data.SqlClient;

using System.ComponentModel; //DataObjectMethod属性(VSのウィザード用)

/// <summary>
/// DrinkObjectDao の概要の説明です
/// </summary>
public class DrinkObjectDao
{
    //コンストラクタ(必須)
    public DrinkObjectDao() { }

    //SELECT(データオブジェクトのリストを取得)
    [DataObjectMethod(DataObjectMethodType.Select)]
    public List<DrinkObject> Select() {
        // System.Data.SqlClient名前空間;
        List<DrinkObject> lists = new List<DrinkObject>();
        String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
        using (SqlConnection con = new SqlConnection(conStr)) {
            con.Open();
            SqlCommand cmd = new SqlCommand("SELECT id,name, price FROM drink", con);
            SqlDataReader reader = cmd.ExecuteReader();
            while (reader.Read()) {
                DrinkObject dto = new DrinkObject();
                dto.Id = (int)reader["id"];
                dto.Name = (string)reader["name"];
                dto.Price = (int)reader["price"];
                lists.Add(dto);
            }
        }
        return lists;
    }

    //UPDATE(データオブジェクト使用)
    [DataObjectMethod(DataObjectMethodType.Update)]
    public int Update(DrinkObject data) {
        int ret;
        String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
        using (SqlConnection con = new SqlConnection(conStr)) {
            SqlCommand cmd = new SqlCommand("UPDATE drink SET [name] = @name, [price] = @price WHERE [id] = @id", con);
            cmd.Parameters.AddWithValue("@id", data.Id);
            cmd.Parameters.AddWithValue("@name", data.Name);
            cmd.Parameters.AddWithValue("@price", data.Price);
            con.Open();
            ret = cmd.ExecuteNonQuery();
        }
        return ret;
    }

    //INSERT(データオブジェクト使用)
    //[DataObjectMethod(DataObjectMethodType.Insert)]
    //public int Insert(DrinkObject data) {
    //    int ret;
    //    String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
    //    using (SqlConnection con = new SqlConnection(conStr)) {
    //        SqlCommand cmd = new SqlCommand("INSERT INTO [drink] ([id], [name], [price]) VALUES (@id, @name, @price)", con);
    //        cmd.Parameters.AddWithValue("@id", data.Id);
    //        cmd.Parameters.AddWithValue("@name", data.Name);
    //        cmd.Parameters.AddWithValue("@price", data.Price);
    //        con.Open();
    //        ret = cmd.ExecuteNonQuery();
    //    }
    //    return ret;
    //}

    //DELETE(データオブジェクト使用)
    //[DataObjectMethod(DataObjectMethodType.Delete)]
    //public int Delete(DrinkObject data) {
    //    int ret;
    //    String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
    //    using (SqlConnection con = new SqlConnection(conStr)) {
    //        SqlCommand cmd = new SqlCommand("DELETE FROM [drink] WHERE [id] = @id", con);
    //        cmd.Parameters.AddWithValue("@id", data.Id);
    //        con.Open();
    //        ret = cmd.ExecuteNonQuery();
    //    }
    //    return ret;
    //}

}
