﻿using System;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

using System.ComponentModel; //DataObjectMethod属性(VSのウィザード用)

public class DrinkPagingDao
{
    //コンストラクタ(必須)
    public DrinkPagingDao() { }

    //SELECT
    [DataObjectMethod(DataObjectMethodType.Select)]
    public DataSet Select() {
        // System.Data.SqlClient名前空間;
        DataSet ds = new DataSet();
        String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
        string query = "SELECT id,name, price FROM drink";
        using (SqlConnection con = new SqlConnection(conStr)) {
            SqlDataAdapter adapter = new SqlDataAdapter(query, con);
            adapter.Fill(ds);
        }
        return ds;
    }

    //ページング用SELECT(データ取得)
    public DataSet Select(int maximumRows, int startRowIndex) {
        DataSet ds = new DataSet();
        String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
        string query = String.Format("SELECT id,name,price FROM (SELECT *, ROW_NUMBER() OVER (ORDER BY id) AS 'rownum' FROM drink ) AS drinktbl WHERE rownum BETWEEN {0} AND {1} ORDER BY id", startRowIndex, startRowIndex + maximumRows);
        using (SqlConnection con = new SqlConnection(conStr)) {
            SqlDataAdapter adapter = new SqlDataAdapter(query, con);
            adapter.Fill(ds);
        }
        return ds;
    }

    //ページング用SELECT(件数取得)
    public int SelectCount() {
        int ret;
        String conStr = ConfigurationManager.ConnectionStrings["MyCon"].ConnectionString;
        using (SqlConnection con = new SqlConnection(conStr)) {
            SqlCommand cmd = new SqlCommand("SELECT count(*) FROM drink", con);
            con.Open();
            ret = (int)cmd.ExecuteScalar();
        }
        return ret;
    }
}
