﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.IO;

public partial class MasterPage : System.Web.UI.MasterPage
{
    //［ページ表示時］
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack) {
            //リクエストが各章の場合は、XPathを変更して、その章のコントロールのみ表示
            string[] req = Request.Path.Split('/');
            if (req[2].StartsWith("0")) {
                XmlChapter.XPath = String.Format("/siteMap/siteMapNode/siteMapNode[contains(@title,\"{0}章\")]", req[2].Substring(1, 1));
                TreeViewChapter.MaxDataBindDepth = 2;
                
                //8/9章の場合は、ログイン情報を表示するパネルを表示
                if (req[2].Substring(1, 1) == "8" || req[2].Substring(1, 1) == "9") {
                    Panel1.Visible = true;
                }

            }else if(Request.Path.Contains("yousyoku")){
                XmlChapter.XPath = "/siteMap/siteMapNode/siteMapNode[contains(@title,\"5章\")]";
                TreeViewChapter.MaxDataBindDepth = 2;
            } else if (Request.Path.Contains("washoku")) {
                XmlChapter.XPath = "/siteMap/siteMapNode/siteMapNode[contains(@title,\"7章\")]";
                TreeViewChapter.MaxDataBindDepth = 2;
            }
            
        }
        
    }


    //［メニューのクリック時］
    //クリックされた章のツリービューを表示
    protected void MenuChapter_MenuItemClick(object sender, MenuEventArgs e) {
        //章のトップページへ移動
        Response.Redirect(String.Format("~/{0}/Default.aspx",MenuChapter.SelectedValue));
    }

    //［サイトマップのデータバインド時］
    //サイトマップのカレントノードを表示
    protected void ChapSiteMap_ItemDataBound(object sender, SiteMapNodeItemEventArgs e) {
        
        //カレントアイテムのサイトマップ表示を設定
        if (e.Item.ItemType == SiteMapNodeItemType.Current) {
            Literal lit = (Literal)e.Item.FindControl("litText");
            if (e.Item.ItemIndex == 3) {
                //最下層の場合、Descriptionを表示
                lit.Text = e.Item.SiteMapNode.Title.Substring(0, 3);
                lit.Text += e.Item.SiteMapNode.Description;

                try {
                    PanelSrc.Visible = true;
                    //ASPXのコードを表示
                    string fileName = (Server.MapPath(Request.Path));
                    using (StreamReader reader = new StreamReader(fileName)) {
                        lblAspx.Text = Server.HtmlEncode(reader.ReadToEnd()).
                            Replace("  ", "&nbsp;").
                            Replace("CodeFile=", "<br />\tCodeFile=").
                            Replace("\t", "&nbsp;&nbsp;").
                            Replace("\r\n", "<br />");
                    }
                    fileName += ".cs";
                    //C#のコードを表示
                    using (StreamReader reader = new StreamReader(fileName)) {
                        lblCode.Text = Server.HtmlEncode(reader.ReadToEnd()).
                            Replace("  ", "&nbsp;").
                            Replace("\t", "&nbsp;&nbsp;").
                            Replace("\r\n", "<br />");
                    }
                } catch (Exception ex) {
                    System.Diagnostics.Debug.Write(ex.ToString());
                }



            } else {
                //最下層以外は、Titleを表示
                lit.Text += e.Item.SiteMapNode.Title;
            }
        }

        //トップページ以外では、ルートは非表示
        if (e.Item.ItemType == SiteMapNodeItemType.Root) {
            if (e.Item.ItemType != SiteMapNodeItemType.Current){
                e.Item.Visible = false;
            }
        }
        //ルートを表示しないため、ルートの後ろの区切り文字を非表示に設定
        if (e.Item.ItemType == SiteMapNodeItemType.PathSeparator) {
            if (e.Item.ItemIndex == 1) {
                e.Item.Visible = false;
            }
        }

    }


    protected void TreeViewChapter_PreRender(object sender, EventArgs e) {
        
        if (ChapSiteMap.Provider.CurrentNode != null) {
            //ページのタイトルを設定
            Page.Title = "ASP.NET辞典～"
                + ChapSiteMap.Provider.CurrentNode.Description + "～";

            //ツリーの最下層の場合は、ノードを選択（着色表示）
            if (!ChapSiteMap.Provider.CurrentNode.HasChildNodes &&
                (ChapSiteMap.Provider.CurrentNode.Title != "ログインページ")) {
                string crntNode = ChapSiteMap.Provider.CurrentNode.Title;
                string prntNode1 = ChapSiteMap.Provider.CurrentNode.ParentNode.Title;
                string prntNode2 = ChapSiteMap.Provider.CurrentNode.ParentNode.ParentNode.Title;
                TreeNode tn = TreeViewChapter.FindNode(prntNode2 + "/" + prntNode1 + "/" + crntNode);
                if (tn != null) {
                    tn.Select();
                }
            }
        
        } else {
            Page.Title = "ASP.NET辞典";
        }

    }
}
