﻿Imports System.Threading

Partial Public Class _02_Page_PageAsync
    Inherits System.Web.UI.Page

    Private _delegate As AsyncTaskDelegate
    Protected Delegate Sub AsyncTaskDelegate()

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        ' 非同期実行の準備
        If Page.IsAsync = True Then
            Page.AsyncTimeout = New TimeSpan(0, 0, 5) '5秒でタイムアウト
            Dim task As New PageAsyncTask(AddressOf BeginEvent, AddressOf EndEvent, AddressOf TimeoutData, Nothing, True)
            Page.RegisterAsyncTask(task)
        End If
    End Sub

    '非同期処理の開始イベント
    Private Function BeginEvent(ByVal sender As Object, ByVal e As EventArgs, ByVal callback As AsyncCallback, ByVal state As Object) As IAsyncResult
        '非同期のメソッドを登録
        _delegate = New AsyncTaskDelegate(AddressOf SlowCalcMethod)
        Return _delegate.BeginInvoke(callback, state)
    End Function

    '時間のかかるメソッド
    Public Sub SlowCalcMethod()
        Thread.Sleep(TimeSpan.FromSeconds(3)) '3秒
        Label1.Text = "正常終了"
    End Sub

    '非同期処理の終了イベント
    Private Sub EndEvent(ByVal ar As IAsyncResult)
        '終処理
        _delegate.EndInvoke(ar)
    End Sub

    'タイムアウト時の処理
    Private Sub TimeoutData(ByVal ar As IAsyncResult)
        Label1.Text = "タイムアウトです"
    End Sub
End Class
