﻿Partial Public Class _02_Page_Request
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        'ユーザーを一意に識別する一時的なCookieを設定
        If Request.Cookies("UniqueKey") Is Nothing Then
            Response.Cookies("UniqueKey").Value = Guid.NewGuid().ToString()
        End If
    End Sub

    Protected Sub LinkButton1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles LinkButton1.Click
        Label1.Text = ""
        For i As Integer = 0 To Request.Form.Count - 1
            'フォーム変数→VIEWSTATE等
            Label1.Text += "<br />" + Request.Form.GetKey(i)
        Next

        Label2.Text = Request.QueryString("selectId")
        'クエリ文字列→Request.aspx?selectId=200の場合、200

        Label3.Text = Request.ServerVariables("HTTP_ACCEPT_LANGUAGE")
        'サーバー変数(言語コード)→ja,en-us;q=0.5

        Label4.Text = Request.Cookies("UniqueKey").Value
        'Cookie(UniqueKey) →36桁の一意なID(3b6cf866-932a-･･･)

        Label5.Text = Request.RequestType
        'HTTPメソッド→ POST

        Label6.Text = Request.UserAgent
        'ブラウザのユーザーエージェント→ Mozilla/4.0 (compatible; ･･･

        Label7.Text = Request.Url.AbsoluteUri
        '絶対URL→ http://localhost:8080/Jiten/02/Page/Request.aspx?selectId=200

        Label8.Text = Request.ApplicationPath
        'ルートパス→ /Jiten

        Label9.Text = Request.AppRelativeCurrentExecutionFilePath
        '相対パス→ ~/02/Page/Request.aspx

        Label10.Text = Request.CurrentExecutionFilePath
        '仮想パス→ /Jiten/02/Page/Request.aspx

    End Sub
End Class
