﻿Partial Public Class _05_DetailsView_DetailsEvents
    Inherits System.Web.UI.Page

    'データ挿入前イベント
    Protected Sub Dv1_ItemInserting(ByVal sender As Object, _
            ByVal e As DetailsViewInsertEventArgs) Handles Dv1.ItemInserting

        For Each de As DictionaryEntry In e.Values
            If de.Value Is Nothing Then   '入力パラメータをチェック
                Label1.Text = "入力データが不足してます"
                e.Cancel = True    '挿入処理をキャンセル
                Return
            End If
        Next
        '登録日と更新日のパラメータに現在日時をセット
        Sql1.InsertParameters("modify_date").DefaultValue = DateTime.Now.ToString("f")
        Sql1.InsertParameters("create_date").DefaultValue = DateTime.Now.ToString("f")

    End Sub

    'データ挿入後イベント
    Protected Sub Dv1_ItemInserted(ByVal sender As Object, _
                ByVal e As DetailsViewInsertedEventArgs) Handles Dv1.ItemInserted

        Label1.Text = e.AffectedRows.ToString() + "件登録されました<br />登録結果<br />"
        For Each de As DictionaryEntry In e.Values
            Label1.Text += de.Key + ":" + de.Value + "<br />"
        Next
        e.KeepInInsertMode = True  '引き続きデータを入力

    End Sub

    'データ更新前イベント
    Protected Sub Dv1_ItemUpdating(ByVal sender As Object, _
                ByVal e As DetailsViewUpdateEventArgs) Handles Dv1.ItemUpdating
        For Each de As DictionaryEntry In e.NewValues
            If de.Value Is Nothing Then    '入力パラメータをチェック
                Label1.Text = "入力データが不足してます"
                e.Cancel = True  '更新処理をキャンセル
                Return
            End If
        Next
        '更新日のパラメータに現在日時をセット
        Sql1.UpdateParameters("modify_date").DefaultValue = DateTime.Now.ToString("f")
    End Sub

    'データ更新後イベント
    Protected Sub Dv1_ItemUpdated(ByVal sender As Object, _
                ByVal e As DetailsViewUpdatedEventArgs) Handles Dv1.ItemUpdated

        Label1.Text = e.AffectedRows.ToString() + "件更新されました<br />更新前データ<br />"
        For Each de As DictionaryEntry In e.OldValues
            Label1.Text += de.Key + ":" + de.Value + "<br />"
        Next

    End Sub

    'データ削除前イベント
    Protected Sub Dv1_ItemDeleting(ByVal sender As Object, _
                ByVal e As DetailsViewDeleteEventArgs) Handles Dv1.ItemDeleting

        If Dv1.DataItemCount <= 5 Then
            Label1.Text = "5件以下にはできません"
            e.Cancel = True
        End If

    End Sub

    'データ削除後イベント
    Protected Sub Dv1_ItemDeleted(ByVal sender As Object, _
            ByVal e As DetailsViewDeletedEventArgs) Handles Dv1.ItemDeleted

        Label1.Text = e.AffectedRows.ToString() + "件削除されました<br />削除データのキー<br />"
        For Each de As DictionaryEntry In e.Keys
            Label1.Text += de.Key + ":" + de.Value.ToString() + "<br />"
        Next

    End Sub

    'データ生成時イベント
    Protected Sub Dv1_ItemCreated(ByVal sender As Object, _
            ByVal e As EventArgs) Handles Dv1.ItemCreated

        If Dv1.CurrentMode = DetailsViewMode.[ReadOnly] Then
            '削除ボタン(6行目→1列目→左から3つめ)に確認スクリプトを追加
            Dim del As LinkButton = DirectCast(Dv1.Rows(5).Cells(0).Controls(2), LinkButton)
            del.OnClientClick = "javascript:return confirm('" + DirectCast(DataBinder.Eval(Dv1.DataItem, "name"), String) + "を削除しますか" + "')"
        End If

    End Sub

    'コマンド時のイベント
    Protected Sub Dv1_ItemCommand(ByVal sender As Object, _
            ByVal e As DetailsViewCommandEventArgs) Handles Dv1.ItemCommand

        If e.CommandName = "HIDE" Then
            Dv1.Fields(5).Visible = False  '編集ボタンを非表示
            Dv1.Fields(6).Visible = False  '隠すボタンを非表示
        End If

    End Sub

End Class
