﻿Imports System
Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Imports System.ComponentModel 'DataObjectMethod属性用

Public Class DrinkDao

    'コンストラクタ必須(ObjectDataSourceによって呼び出される)
    Public Sub New()
    End Sub

    'SELECTメソッド(DataObjectMethod属性はVSのウィザード用)
    <DataObjectMethod(DataObjectMethodType.[Select])> _
    Public Function [Select]() As DataSet
        ' System.Data.SqlClient名前空間;
        Dim ds As New DataSet()
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Dim query As String = "SELECT id,name, price FROM drink"
        Using con As New SqlConnection(conStr)
            Dim adapter As New SqlDataAdapter(query, con)
            adapter.Fill(ds)
        End Using
        Return ds
    End Function

    'UPDATE(DataObjectMethod属性はVSのウィザード用)
    <DataObjectMethod(DataObjectMethodType.Update)> _
    Public Function Update(ByVal id As Integer, ByVal name As String, ByVal price As Integer) As Integer
        Dim ret As Integer
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Using con As New SqlConnection(conStr)
            Dim cmd As New SqlCommand("UPDATE drink SET [name] = @name, [price] = @price WHERE [id] = @id", con)
            cmd.Parameters.AddWithValue("@id", id)
            cmd.Parameters.AddWithValue("@name", name)
            cmd.Parameters.AddWithValue("@price", price)
            con.Open()
            ret = cmd.ExecuteNonQuery()
        End Using
        Return ret
    End Function

    'INSERT(DataObjectMethod属性はVSのウィザード用)
    <DataObjectMethod(DataObjectMethodType.Insert)> _
    Public Function Insert(ByVal id As Integer, ByVal name As String, ByVal price As Integer) As Integer
        Dim ret As Integer
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Using con As New SqlConnection(conStr)
            Dim cmd As New SqlCommand("INSERT INTO [drink] ([id], [name], [price]) VALUES (@id, @name, @price)", con)
            cmd.Parameters.AddWithValue("@id", id)
            cmd.Parameters.AddWithValue("@name", name)
            cmd.Parameters.AddWithValue("@price", price)
            con.Open()
            ret = cmd.ExecuteNonQuery()
        End Using
        Return ret
    End Function

    'DELETE(DataObjectMethod属性はVSのウィザード用)
    <DataObjectMethod(DataObjectMethodType.Delete)> _
    Public Function Delete(ByVal id As Integer) As Integer
        Dim ret As Integer
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Using con As New SqlConnection(conStr)
            Dim cmd As New SqlCommand("DELETE FROM [drink] WHERE [id] = @id", con)
            cmd.Parameters.AddWithValue("@id", id)
            con.Open()
            ret = cmd.ExecuteNonQuery()
        End Using
        Return ret
    End Function

End Class
