﻿Imports System
Imports System.Data
Imports System.Configuration
Imports System.Collections.Generic
Imports System.Data.SqlClient
Imports System.ComponentModel 'DataObjectMethod属性(VSのウィザード用)

' <summary>
' DrinkObjectDao の概要の説明です
' </summary>
Public Class DrinkObjectDao

    'コンストラクタ(必須)
    Public Sub New()
    End Sub

    'SELECT(データオブジェクトのリストを取得)
    <DataObjectMethod(DataObjectMethodType.[Select])> _
    Public Function [Select]() As List(Of DrinkObject)
        ' System.Data.SqlClient名前空間;
        Dim lists As New List(Of DrinkObject)()
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Using con As New SqlConnection(conStr)
            con.Open()
            Dim cmd As New SqlCommand("SELECT id,name, price FROM drink", con)
            Dim reader As SqlDataReader = cmd.ExecuteReader()
            While reader.Read()
                Dim dto As New DrinkObject()
                dto.Id = DirectCast(reader("id"), Integer)
                dto.Name = DirectCast(reader("name"), String)
                dto.Price = DirectCast(reader("price"), Integer)
                lists.Add(dto)
            End While
        End Using
        Return lists
    End Function

    'UPDATE(データオブジェクト使用)
    <DataObjectMethod(DataObjectMethodType.Update)> _
    Public Function Update(ByVal data As DrinkObject) As Integer
        Dim ret As Integer
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Using con As New SqlConnection(conStr)
            Dim cmd As New SqlCommand("UPDATE drink SET [name] = @name, [price] = @price WHERE [id] = @id", con)
            cmd.Parameters.AddWithValue("@id", data.Id)
            cmd.Parameters.AddWithValue("@name", data.Name)
            cmd.Parameters.AddWithValue("@price", data.Price)
            con.Open()
            ret = cmd.ExecuteNonQuery()
        End Using
        Return ret
    End Function

    'INSERT(データオブジェクト使用)
    '<DataObjectMethod(DataObjectMethodType.Insert)> _
    'Public Function Insert(ByVal data As DrinkObject) As Integer
    '    Dim ret As Integer
    '    Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
    '    Using con As New SqlConnection(conStr)
    '        Dim cmd As New SqlCommand("INSERT INTO [drink] ([id], [name], [price]) VALUES (@id, @name, @price)", con)
    '        cmd.Parameters.AddWithValue("@id", data.Id)
    '        cmd.Parameters.AddWithValue("@name", data.Name)
    '        cmd.Parameters.AddWithValue("@price", data.Price)
    '        con.Open()
    '        ret = cmd.ExecuteNonQuery()
    '    End Using
    '    Return ret
    'End Function

    'DELETE(データオブジェクト使用)
    '<DataObjectMethod(DataObjectMethodType.Delete)> _
    'Public Function Delete(ByVal data As DrinkObject) As Integer
    '    Dim ret As Integer
    '    Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
    '    Using con As New SqlConnection(conStr)
    '        Dim cmd As New SqlCommand("DELETE FROM [drink] WHERE [id] = @id", con)
    '        cmd.Parameters.AddWithValue("@id", data.Id)
    '        con.Open()
    '        ret = cmd.ExecuteNonQuery()
    '    End Using
    '    Return ret
    'End Function

End Class
