﻿Imports System
Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Imports System.ComponentModel  'DataObjectMethod属性(VSのウィザード用)

Public Class DrinkPagingDao

    'コンストラクタ(必須)
    Public Sub New()
    End Sub

    'SELECT
    <DataObjectMethod(DataObjectMethodType.[Select])> _
    Public Function [Select]() As DataSet
        ' System.Data.SqlClient名前空間;
        Dim ds As New DataSet()
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Dim query As String = "SELECT id,name, price FROM drink"
        Using con As New SqlConnection(conStr)
            Dim adapter As New SqlDataAdapter(query, con)
            adapter.Fill(ds)
        End Using
        Return ds
    End Function

    'ページング用SELECT(データ取得)
    Public Function [Select](ByVal maximumRows As Integer, ByVal startRowIndex As Integer) As DataSet
        Dim ds As New DataSet()
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Dim query As String = [String].Format("SELECT id,name,price FROM (SELECT *, ROW_NUMBER() OVER (ORDER BY id) AS 'rownum' FROM drink ) AS drinktbl WHERE rownum BETWEEN {0} AND {1} ORDER BY id", startRowIndex, startRowIndex + maximumRows)
        Using con As New SqlConnection(conStr)
            Dim adapter As New SqlDataAdapter(query, con)
            adapter.Fill(ds)
        End Using
        Return ds
    End Function

    'ページング用SELECT(件数取得)
    Public Function SelectCount() As Integer
        Dim ret As Integer
        Dim conStr As String = ConfigurationManager.ConnectionStrings("MyCon").ConnectionString
        Using con As New SqlConnection(conStr)
            Dim cmd As New SqlCommand("SELECT count(*) FROM drink", con)
            con.Open()
            ret = DirectCast(cmd.ExecuteScalar(), Integer)
        End Using
        Return ret
    End Function

End Class
