﻿Imports System.IO

Partial Public Class MasterPage
    Inherits System.Web.UI.MasterPage

    '［ページ表示時］
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Init
        If Not Page.IsPostBack Then
            'リクエストが各章の場合は、XPathを変更して、その章のコントロールのみ表示
            Dim req As String() = Request.Path.Split("/"c)
            If req(2).StartsWith("0") Then
                XmlChapter.XPath = [String].Format("/siteMap/siteMapNode/siteMapNode[contains(@title,""{0}章"")]", req(2).Substring(1, 1))
                TreeViewChapter.MaxDataBindDepth = 2

                '8/9章の場合は、ログイン情報を表示するパネルを表示
                If req(2).Substring(1, 1) = "8" Or req(2).Substring(1, 1) = "9" Then
                    Panel1.Visible = True
                End If
            ElseIf Request.Path.Contains("yousyoku") Then
                XmlChapter.XPath = "/siteMap/siteMapNode/siteMapNode[contains(@title,""5章"")]"
                TreeViewChapter.MaxDataBindDepth = 2
            ElseIf Request.Path.Contains("washoku") Then
                XmlChapter.XPath = "/siteMap/siteMapNode/siteMapNode[contains(@title,""7章"")]"
                TreeViewChapter.MaxDataBindDepth = 2
            End If

        End If
    End Sub

    '［メニューのクリック時］
    'クリックされた章のツリービューを表示
    Protected Sub MenuChapter_MenuItemClick(ByVal sender As Object, ByVal e As MenuEventArgs) Handles MenuChapter.MenuItemClick
        '章のトップページへ移動
        Response.Redirect([String].Format("~/{0}/Default.aspx", MenuChapter.SelectedValue))
    End Sub

    '［サイトマップのデータバインド時］
    'サイトマップのカレントノードを表示
    Protected Sub ChapSiteMap_ItemDataBound(ByVal sender As Object, ByVal e As SiteMapNodeItemEventArgs) Handles ChapSiteMap.ItemDataBound
        'カレントアイテムのサイトマップ表示を設定
        If e.Item.ItemType = SiteMapNodeItemType.Current Then
            Dim lit As Literal = DirectCast(e.Item.FindControl("litText"), Literal)
            If e.Item.ItemIndex = 3 Then
                '最下層の場合、Descriptionを表示
                lit.Text = e.Item.SiteMapNode.Title.Substring(0, 3)
                lit.Text += e.Item.SiteMapNode.Description
                Try
                    PanelSrc.Visible = True
                    'ASPXのコードを表示
                    Dim fileName As String = (Server.MapPath(Request.Path))
                    Using reader As New StreamReader(fileName)
                        lblAspx.Text = Server.HtmlEncode(reader.ReadToEnd()).Replace("  ", "&nbsp;").Replace("CodeFile=", "<br />" & Chr(9) & "CodeFile=").Replace("" & Chr(9) & "", "&nbsp;&nbsp;").Replace("" & Chr(13) & "" & Chr(10) & "", "<br />")
                    End Using
                    fileName += ".vb"
                    'VBのコードを表示
                    Using reader As New StreamReader(fileName)
                        lblCode.Text = Server.HtmlEncode(reader.ReadToEnd()).Replace("  ", "&nbsp;").Replace("" & Chr(9) & "", "&nbsp;&nbsp;").Replace("" & Chr(13) & "" & Chr(10) & "", "<br />")
                    End Using
                Catch ex As Exception
                    System.Diagnostics.Debug.Write(ex.ToString())
                End Try
            Else
                '最下層以外は、Titleを表示
                lit.Text += e.Item.SiteMapNode.Title
            End If
        End If
        'トップページ以外では、ルートは非表示
        If e.Item.ItemType = SiteMapNodeItemType.Root Then
            If e.Item.ItemType <> SiteMapNodeItemType.Current Then
                e.Item.Visible = False
            End If
        End If
        'ルートを表示しないため、ルートの後ろの区切り文字を非表示に設定
        If e.Item.ItemType = SiteMapNodeItemType.PathSeparator Then
            If e.Item.ItemIndex = 1 Then
                e.Item.Visible = False
            End If
        End If
    End Sub
    Protected Sub TreeViewChapter_PreRender(ByVal sender As Object, ByVal e As EventArgs) Handles TreeViewChapter.PreRender
        'ページのタイトルを設定
        If ChapSiteMap.Provider.CurrentNode IsNot Nothing Then
            Page.Title = "ASP.NET辞典～" + ChapSiteMap.Provider.CurrentNode.Description + "～"

            'ツリーの最下層の場合は、ノードを選択（着色表示）
            If Not ChapSiteMap.Provider.CurrentNode.HasChildNodes AndAlso (ChapSiteMap.Provider.CurrentNode.Title <> "ログインページ") Then
                Dim crntNode As String = ChapSiteMap.Provider.CurrentNode.Title
                Dim prntNode1 As String = ChapSiteMap.Provider.CurrentNode.ParentNode.Title
                Dim prntNode2 As String = ChapSiteMap.Provider.CurrentNode.ParentNode.ParentNode.Title
                Dim tn As TreeNode = TreeViewChapter.FindNode(prntNode2 + "/" + prntNode1 + "/" + crntNode)
                If tn IsNot Nothing Then
                    tn.Select()
                End If
            End If

        Else
            Page.Title = "ASP.NET辞典"
        End If

    End Sub
End Class
